/*----- PROTECTED REGION ID(Keithley2001.h) ENABLED START -----*/
//=============================================================================
//
// file :        Keithley2001.h
//
// description : Include file for the Keithley2001 class
//
// project :     Keithley 2001
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Keithley2001_H
#define Keithley2001_H

#include <tango.h>
#include "DeviceProxyHelper.h"
#include "task/KeithleyManager.hpp"

/*----- PROTECTED REGION END -----*/	//	Keithley2001.h

/**
 *  Keithley2001 class description:
 *    Class to monitor the temperature from a Keithley2001
 */

namespace Keithley2001_ns
{
/*----- PROTECTED REGION ID(Keithley2001::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	Keithley2001::Additional Class Declarations

class Keithley2001 : public Tango::Device_4Impl
{

/*----- PROTECTED REGION ID(Keithley2001::Data Members) ENABLED START -----*/

//	Add your own data members

/*----- PROTECTED REGION END -----*/	//	Keithley2001::Data Members

//	Device property data members
public:
	//	CommunicationLink:	Device which handles the communication protocol (here GPIB)
	string	communicationLink;
	//	Configuration:	List of commands to configure the Keithley
	vector<string>	configuration;

//	Attribute data members
public:
	Tango::DevDouble	*attr_temperature_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Keithley2001(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Keithley2001(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Keithley2001(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */	
	~Keithley2001() {delete_device();}


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : Keithley2001::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute temperature related methods
 *	Description: The measured temperature value in degre Celsius
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_temperature(Tango::Attribute &attr);
	virtual bool is_temperature_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method      : Keithley2001::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();



//	Command related methods
public:
	/**
	 *	Command State related method
	 *	Description: This command gets the device state (stored in its device_state data member) and returns it to the caller.
	 *
	 *	@returns Device state
	 */
	virtual Tango::DevState dev_state();
	/**
	 *	Command SaveConfig related method
	 *	Description: This command saves the current Keithley configuration in an available memory slot. <Br>
	 *               - No extended memory : slot 0 only                     <Br>
	 *               - Model 2001-MEME1 : from 0 to 4                     <Br>
	 *               - Model 2001-MEME2 : from 0 to 9                     <Br>
	 *               <Br>
	 *               NOTE : the current model has no extended memory (only slot0 is available).
	 *
	 */
	virtual void save_config();
	virtual bool is_SaveConfig_allowed(const CORBA::Any &any);
	/**
	 *	Command RestoreConfig related method
	 *	Description: This command restores the previously saved Keithley configuration from an available memory slot. <Br>
	 *               - No extended memory : slot 0 only                     <Br>
	 *               - Model 2001-MEME1 : from 0 to 4                     <Br>
	 *               - Model 2001-MEME2 : from 0 to 9                     <Br>
	 *               <Br>
	 *               NOTE : the current model has no extended memory (only slot0 is available).
	 *
	 */
	virtual void restore_config();
	virtual bool is_RestoreConfig_allowed(const CORBA::Any &any);


/*----- PROTECTED REGION ID(Keithley2001::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes
private:

	bool m_initDone;
	yat::UniquePtr<KeithleyManager, yat4tango::DeviceTaskExiter> m_task_ptr;	
	std::string m_status; //- device status

	void create_task();
	void delete_task();

/*----- PROTECTED REGION END -----*/	//	Keithley2001::Additional Method prototypes
};

/*----- PROTECTED REGION ID(Keithley2001::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	Keithley2001::Additional Classes Definitions

}	//	End of namespace

#endif   //	Keithley2001_H
